<!--
The top level view that shows the information of a competition.

Queries the backend handler to retrieve the full set of information
surrounding a competition before rendering.
-->
<template>
  <div id="app">
    <b-card style="margin: 10px">
      <h6 slot="header" class="mb-0" style="font-weight: bold;">{{ this.competition.getTitle() }}</h6>
      <div style="float:left">
        <competition-info-panel :competition="this.competition"/>
        <competition-tags-panel :competition="this.competition"/>
        <competition-description-panel :competition="this.competition"/>
      </div>
      <b-card>
        <iframe width="100%" height="550px" :src="competition.getEmbedUrl()" scrolling="yes"></iframe>
      </b-card>
    <!-- router-link :to="'/Submit/' + $route.params.id">Add a Submission</router-link -->
    </b-card>
  </div>
</template>

<script>
import backend from '@/backend-manager'
import Competition from '@/models/Competition'
import Tag from '@/models/Tag'

import CompetitionInfoPanel from '@/components/CompetitionInfoPanel'
import CompetitionTagsPanel from '@/components/CompetitionTagsPanel'
import CompetitionDescriptionPanel from '@/components/CompetitionDescriptionPanel'

export default {
    created: async function () {
        this.competition = new Competition(this.$route.params.id)
        await this.competition.load()
    },
    components: {
        CompetitionInfoPanel: CompetitionInfoPanel,
        CompetitionTagsPanel: CompetitionTagsPanel,
        CompetitionDescriptionPanel: CompetitionDescriptionPanel
    },
    data: function () {
        return {
            competition: {}
        }
    }
  
}
</script>
